/// YApi QuickType插件生成，具体参考文档:https://plugins.jetbrains.com/plugin/18847-yapi-quicktype/documentation

import 'dart:convert';

import 'package:widgets/load_state_layout.dart';

class PropertyRentState {
  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;

  int? page;
  int? limit = 10;
  int? count = 0;
  List<Map<String, dynamic>> list;

  PropertyRentState({
    this.loadingState = LoadState.State_Loading,
    String? errorMessage,
    this.page = 1,
    this.limit = 10,
    this.count = 0,
    required this.list,
  });
  Map<String, dynamic> toMap() {
    return {
      'loadingState': this.loadingState,
      'errorMessage': this.errorMessage,
      'page': this.page,
      'limit': this.limit,
      'count': this.count,
      'list': this.list,
    };
  }

  factory PropertyRentState.fromMap(Map<String, dynamic> map) {
    return PropertyRentState(
      loadingState: map['loadingState'] as LoadState,
      errorMessage: map['errorMessage'] as String,
      page: map['page'] as int,
      limit: map['limit'] as int,
      count: map['count'] as int,
      list: map['list'] as List<Map<String, dynamic>>,
    );
  }

  PropertyRentState copyWith({
    LoadState? loadingState,
    String? errorMessage,
    int? page,
    int? limit,
    int? count,
    List<Map<String, dynamic>>? list,
  }) {
    return PropertyRentState(
      loadingState: loadingState ?? this.loadingState,
      errorMessage: errorMessage ?? this.errorMessage,
      page: page ?? this.page,
      limit: limit ?? this.limit,
      count: count ?? this.count,
      list: list ?? this.list,
    );
  }

}
